//+-------------------------------------------------------------------+
//|                                                                   |
//+-------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  DeepSkyBlue
#property indicator_color2  Red
#property indicator_width1  2
#property indicator_width2  2
#property indicator_minimum 0
#property indicator_maximum 1
//
//
//
//
//

extern int  Price  = PRICE_MEDIAN;

//
//
//
//
//

double trend[];
double trendUp[];
double trendDn[];
double filter[];
double signal[];

//+-------------------------------------------------------------------+
//|                                                                   |
//+-------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,trendUp); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,trendDn); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,filter);
   SetIndexBuffer(3,signal);
   SetIndexBuffer(4,trend);
      IndicatorShortName("iMax");
 return (0);
}
  
//+-------------------------------------------------------------------+
//|                                                                   |
//+-------------------------------------------------------------------+
//
//
//
//
//

int start()
{    
   int countedBars = IndicatorCounted();
   int i,limit;

   if(countedBars < 0) {return (-1);}
   if(countedBars > 0) {countedBars--;}
           limit = MathMin(Bars-countedBars-1,Bars-1);

   //
   //
   //
   //
   //

   for(i = limit; i >= 0; i--)
   {
      double price = iMA(NULL,0,1,0,MODE_SMA,Price,i);
         filter[i] = iOptimumEllipticFilter(price,i);
         signal[i] = filter[i+1];
         
         //
         //
         //
         //
         //
         
         trendUp[i] = EMPTY_VALUE;
         trendDn[i] = EMPTY_VALUE;
         trend[i]   = trend[i+1];
            if (filter[i]>signal[i]) trend[i]= 1;
            if (filter[i]<signal[i]) trend[i]=-1;
            if (trend[i]== 1) trendUp[i]=1;
            if (trend[i]==-1) trendDn[i]=1;
   }
   return (0);  
}


//+-------------------------------------------------------------------+
//|                                                                   |
//+-------------------------------------------------------------------+
//
//
//
//
//

double   ioeWork[][2];
#define _ioePrice  0
#define _ioeSmooth 1

//
//
//
//
//

double iOptimumEllipticFilter(double price, int i)
{
   if (ArrayRange(ioeWork,0)!=Bars) ArrayResize(ioeWork,Bars);
   
   int r = Bars-i-1;
      ioeWork[r][_ioePrice]  = price;
      ioeWork[r][_ioeSmooth] = 0.13785*(2.0*ioeWork[r  ][_ioePrice] - ioeWork[r-1][_ioePrice]) +
                               0.0007 *(2.0*ioeWork[r-1][_ioePrice] - ioeWork[r-2][_ioePrice]) +
                               0.13785*(2.0*ioeWork[r-2][_ioePrice] - ioeWork[r-3][_ioePrice]) + 
                               1.2103*ioeWork[r-1][_ioeSmooth] - 0.4867*ioeWork[r-2][_ioeSmooth];
   return(ioeWork[r][_ioeSmooth]);
}